package countandsay

import "fmt"

func say(num string) string {
	freq := 0
	curr := rune(num[0])
	result := ""

	insert := func() { result = fmt.Sprintf("%s%d%c", result, freq, curr) }

	for _, digit := range num {
		if digit == curr {
			freq++
		} else {
			insert()
			curr = digit
			freq = 1
		}
	}
	insert()
	return result
}

func countAndSay(n int) string {
	if n <= 1 {
		return "1"
	}

	prev := countAndSay(n - 1)
	return say(prev)

}

func Nth(n int) string {
	return countAndSay(n)
}
