package lastword_test

import (
	"testing"

	"git.jxs.me/leetgo/lastword"
	"github.com/stretchr/testify/require"
)

func TestExamples(t *testing.T) {
	cases := map[string]int{
		"":                    0,
		"hello":               5,
		"hello computer":      8,
		" goodbye my friend ": 6,
	}
	for input, expected := range cases {
		t.Run(input, func(t *testing.T) {
			result := lastword.LengthOfLastWord(input)
			require.Equal(t, expected, result)
		})
	}
}
