package norepeat_test

import (
	"testing"

	"git.jxs.me/leetgo/norepeat"
	"github.com/stretchr/testify/require"
)

func TestEmpty(t *testing.T) {
	result := norepeat.LengthOfLongestSubstring("")

	require.Equal(t, 0, result)
}

func TestSingle(t *testing.T) {
	result := norepeat.LengthOfLongestSubstring("a")

	require.Equal(t, 1, result)
}

func TestDouble(t *testing.T) {
	result := norepeat.LengthOfLongestSubstring("ab")

	require.Equal(t, 2, result)
}

func TestRepeat(t *testing.T) {
	result := norepeat.LengthOfLongestSubstring("dad")

	require.Equal(t, 2, result)
}

func TestQuad(t *testing.T) {
	result := norepeat.LengthOfLongestSubstring("hellllo")

	require.Equal(t, 3, result)
}
