package reversewords_test

import (
	"fmt"
	"testing"

	"git.jxs.me/leetgo/reversewords"
)

func TestExamples(t *testing.T) {
	cases := map[string]string{
		"":                            "",
		"foo":                         "oof",
		"Hello World":                 "olleH dlroW",
		"Let's take LeetCode contest": "s'teL ekat edoCteeL tsetnoc",
	}

	for source, expected := range cases {
		t.Run(fmt.Sprintf("Check %q", source), func(t *testing.T) {
			result := reversewords.ReverseWords(source)

			if expected != result {
				t.Errorf("%q != %q", expected, result)
			}
		})

	}

}
