package runningsum

func runningSum(nums []int) []int {
	result := make([]int, len(nums))
	total := 0
	for i, num := range nums {
		total += num
		result[i] = total
	}

	return result
}

func RunningSum(nums []int) []int {
	return runningSum(nums)
}
