package validparens_test

import (
	"testing"

	"git.jxs.me/leetgo/validparens"
	"github.com/stretchr/testify/require"
)

func TestExamples(t *testing.T) {
	cases := map[string]bool{
		"":       true,
		"(":      false,
		"()":     true,
		"[{()}]": true,
		"[(])":   false,
	}

	for input, expected := range cases {
		require.Equal(t, expected, validparens.IsValid(input))
	}
}
